/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the SendTemplateRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SendTemplateRequest{}

// SendTemplateRequest Either `template_id` or `template_name` is required
type SendTemplateRequest struct {
	To string `json:"to"`
	ReceiverType *ReceiverType `json:"receiver_type,omitempty"`
	GatewayId string `json:"gateway_id"`
	TemplateId string `json:"template_id"`
	TemplateName string `json:"template_name"`
	Source *string `json:"source,omitempty"`
	// Applicable for sending by name only
	Language *string `json:"language,omitempty"`
	// Applicable for sending by name only, when `true` we'll look for template in channels default language
	LanguageDefaultFallback *bool `json:"language_default_fallback,omitempty"`
	// It will automatically transform template to standard message where applicable
	CostOptimized *bool `json:"cost_optimized,omitempty"`
	// key value map with template parameters, ex. {\"name\": \"Tester\", \"city\": \"Berlin\"
	InternalComponents map[string]interface{} `json:"internal_components,omitempty"`
	WhatsappComponents []WhatsAppTemplateMessageComponent `json:"whatsapp_components,omitempty"`
	Labels []string `json:"labels,omitempty"`
	Context *SendMessageContext `json:"context,omitempty"`
	// For internal use only, in standard api call this parameter will be ignored.
	SenderUserId *string `json:"sender_user_id,omitempty"`
}

// NewSendTemplateRequest instantiates a new SendTemplateRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSendTemplateRequest(to string, gatewayId string, templateId string, templateName string) *SendTemplateRequest {
	this := SendTemplateRequest{}
	this.To = to
	this.GatewayId = gatewayId
	this.TemplateId = templateId
	this.TemplateName = templateName
	return &this
}

// NewSendTemplateRequestWithDefaults instantiates a new SendTemplateRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSendTemplateRequestWithDefaults() *SendTemplateRequest {
	this := SendTemplateRequest{}
	return &this
}

// GetTo returns the To field value
func (o *SendTemplateRequest) GetTo() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.To
}

// GetToOk returns a tuple with the To field value
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetToOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.To, true
}

// SetTo sets field value
func (o *SendTemplateRequest) SetTo(v string) {
	o.To = v
}

// GetReceiverType returns the ReceiverType field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetReceiverType() ReceiverType {
	if o == nil || IsNil(o.ReceiverType) {
		var ret ReceiverType
		return ret
	}
	return *o.ReceiverType
}

// GetReceiverTypeOk returns a tuple with the ReceiverType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetReceiverTypeOk() (*ReceiverType, bool) {
	if o == nil || IsNil(o.ReceiverType) {
		return nil, false
	}
	return o.ReceiverType, true
}

// HasReceiverType returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasReceiverType() bool {
	if o != nil && !IsNil(o.ReceiverType) {
		return true
	}

	return false
}

// SetReceiverType gets a reference to the given ReceiverType and assigns it to the ReceiverType field.
func (o *SendTemplateRequest) SetReceiverType(v ReceiverType) {
	o.ReceiverType = &v
}

// GetGatewayId returns the GatewayId field value
func (o *SendTemplateRequest) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *SendTemplateRequest) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetTemplateId returns the TemplateId field value
func (o *SendTemplateRequest) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *SendTemplateRequest) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetTemplateName returns the TemplateName field value
func (o *SendTemplateRequest) GetTemplateName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateName
}

// GetTemplateNameOk returns a tuple with the TemplateName field value
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetTemplateNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateName, true
}

// SetTemplateName sets field value
func (o *SendTemplateRequest) SetTemplateName(v string) {
	o.TemplateName = v
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *SendTemplateRequest) SetSource(v string) {
	o.Source = &v
}

// GetLanguage returns the Language field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetLanguage() string {
	if o == nil || IsNil(o.Language) {
		var ret string
		return ret
	}
	return *o.Language
}

// GetLanguageOk returns a tuple with the Language field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.Language) {
		return nil, false
	}
	return o.Language, true
}

// HasLanguage returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasLanguage() bool {
	if o != nil && !IsNil(o.Language) {
		return true
	}

	return false
}

// SetLanguage gets a reference to the given string and assigns it to the Language field.
func (o *SendTemplateRequest) SetLanguage(v string) {
	o.Language = &v
}

// GetLanguageDefaultFallback returns the LanguageDefaultFallback field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetLanguageDefaultFallback() bool {
	if o == nil || IsNil(o.LanguageDefaultFallback) {
		var ret bool
		return ret
	}
	return *o.LanguageDefaultFallback
}

// GetLanguageDefaultFallbackOk returns a tuple with the LanguageDefaultFallback field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetLanguageDefaultFallbackOk() (*bool, bool) {
	if o == nil || IsNil(o.LanguageDefaultFallback) {
		return nil, false
	}
	return o.LanguageDefaultFallback, true
}

// HasLanguageDefaultFallback returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasLanguageDefaultFallback() bool {
	if o != nil && !IsNil(o.LanguageDefaultFallback) {
		return true
	}

	return false
}

// SetLanguageDefaultFallback gets a reference to the given bool and assigns it to the LanguageDefaultFallback field.
func (o *SendTemplateRequest) SetLanguageDefaultFallback(v bool) {
	o.LanguageDefaultFallback = &v
}

// GetCostOptimized returns the CostOptimized field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetCostOptimized() bool {
	if o == nil || IsNil(o.CostOptimized) {
		var ret bool
		return ret
	}
	return *o.CostOptimized
}

// GetCostOptimizedOk returns a tuple with the CostOptimized field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetCostOptimizedOk() (*bool, bool) {
	if o == nil || IsNil(o.CostOptimized) {
		return nil, false
	}
	return o.CostOptimized, true
}

// HasCostOptimized returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasCostOptimized() bool {
	if o != nil && !IsNil(o.CostOptimized) {
		return true
	}

	return false
}

// SetCostOptimized gets a reference to the given bool and assigns it to the CostOptimized field.
func (o *SendTemplateRequest) SetCostOptimized(v bool) {
	o.CostOptimized = &v
}

// GetInternalComponents returns the InternalComponents field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetInternalComponents() map[string]interface{} {
	if o == nil || IsNil(o.InternalComponents) {
		var ret map[string]interface{}
		return ret
	}
	return o.InternalComponents
}

// GetInternalComponentsOk returns a tuple with the InternalComponents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetInternalComponentsOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.InternalComponents) {
		return map[string]interface{}{}, false
	}
	return o.InternalComponents, true
}

// HasInternalComponents returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasInternalComponents() bool {
	if o != nil && !IsNil(o.InternalComponents) {
		return true
	}

	return false
}

// SetInternalComponents gets a reference to the given map[string]interface{} and assigns it to the InternalComponents field.
func (o *SendTemplateRequest) SetInternalComponents(v map[string]interface{}) {
	o.InternalComponents = v
}

// GetWhatsappComponents returns the WhatsappComponents field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetWhatsappComponents() []WhatsAppTemplateMessageComponent {
	if o == nil || IsNil(o.WhatsappComponents) {
		var ret []WhatsAppTemplateMessageComponent
		return ret
	}
	return o.WhatsappComponents
}

// GetWhatsappComponentsOk returns a tuple with the WhatsappComponents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetWhatsappComponentsOk() ([]WhatsAppTemplateMessageComponent, bool) {
	if o == nil || IsNil(o.WhatsappComponents) {
		return nil, false
	}
	return o.WhatsappComponents, true
}

// HasWhatsappComponents returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasWhatsappComponents() bool {
	if o != nil && !IsNil(o.WhatsappComponents) {
		return true
	}

	return false
}

// SetWhatsappComponents gets a reference to the given []WhatsAppTemplateMessageComponent and assigns it to the WhatsappComponents field.
func (o *SendTemplateRequest) SetWhatsappComponents(v []WhatsAppTemplateMessageComponent) {
	o.WhatsappComponents = v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *SendTemplateRequest) SetLabels(v []string) {
	o.Labels = v
}

// GetContext returns the Context field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetContext() SendMessageContext {
	if o == nil || IsNil(o.Context) {
		var ret SendMessageContext
		return ret
	}
	return *o.Context
}

// GetContextOk returns a tuple with the Context field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetContextOk() (*SendMessageContext, bool) {
	if o == nil || IsNil(o.Context) {
		return nil, false
	}
	return o.Context, true
}

// HasContext returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasContext() bool {
	if o != nil && !IsNil(o.Context) {
		return true
	}

	return false
}

// SetContext gets a reference to the given SendMessageContext and assigns it to the Context field.
func (o *SendTemplateRequest) SetContext(v SendMessageContext) {
	o.Context = &v
}

// GetSenderUserId returns the SenderUserId field value if set, zero value otherwise.
func (o *SendTemplateRequest) GetSenderUserId() string {
	if o == nil || IsNil(o.SenderUserId) {
		var ret string
		return ret
	}
	return *o.SenderUserId
}

// GetSenderUserIdOk returns a tuple with the SenderUserId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SendTemplateRequest) GetSenderUserIdOk() (*string, bool) {
	if o == nil || IsNil(o.SenderUserId) {
		return nil, false
	}
	return o.SenderUserId, true
}

// HasSenderUserId returns a boolean if a field has been set.
func (o *SendTemplateRequest) HasSenderUserId() bool {
	if o != nil && !IsNil(o.SenderUserId) {
		return true
	}

	return false
}

// SetSenderUserId gets a reference to the given string and assigns it to the SenderUserId field.
func (o *SendTemplateRequest) SetSenderUserId(v string) {
	o.SenderUserId = &v
}

func (o SendTemplateRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SendTemplateRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["to"] = o.To
	if !IsNil(o.ReceiverType) {
		toSerialize["receiver_type"] = o.ReceiverType
	}
	toSerialize["gateway_id"] = o.GatewayId
	toSerialize["template_id"] = o.TemplateId
	toSerialize["template_name"] = o.TemplateName
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Language) {
		toSerialize["language"] = o.Language
	}
	if !IsNil(o.LanguageDefaultFallback) {
		toSerialize["language_default_fallback"] = o.LanguageDefaultFallback
	}
	if !IsNil(o.CostOptimized) {
		toSerialize["cost_optimized"] = o.CostOptimized
	}
	if !IsNil(o.InternalComponents) {
		toSerialize["internal_components"] = o.InternalComponents
	}
	if !IsNil(o.WhatsappComponents) {
		toSerialize["whatsapp_components"] = o.WhatsappComponents
	}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	if !IsNil(o.Context) {
		toSerialize["context"] = o.Context
	}
	if !IsNil(o.SenderUserId) {
		toSerialize["sender_user_id"] = o.SenderUserId
	}
	return toSerialize, nil
}

type NullableSendTemplateRequest struct {
	value *SendTemplateRequest
	isSet bool
}

func (v NullableSendTemplateRequest) Get() *SendTemplateRequest {
	return v.value
}

func (v *NullableSendTemplateRequest) Set(val *SendTemplateRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableSendTemplateRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableSendTemplateRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSendTemplateRequest(val *SendTemplateRequest) *NullableSendTemplateRequest {
	return &NullableSendTemplateRequest{value: val, isSet: true}
}

func (v NullableSendTemplateRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSendTemplateRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


